######################################################################################
#  This program looks for the data blocks of the given cif                          #
#     with the purpose of being integrated into the B-IncStrDB                     #
###################################################################################
import iotbx.cif
from iotbx.cif import validation 
import sys

class Logger(object):
    def __init__(self, filename="Default.log"):
        self.terminal = sys.stdout
        self.log = open(filename, "w")

    def write(self, message):
        self.terminal.write(message)
        self.log.write(message)
        self.log.close



def validate(cifname):


 if cifname.endswith(".cif")== False:
   sys.stdout = Logger("errors.txt")
   print " CifBuilderError: %s file is not a cif file"%(cifname)
   sys.exit()
 else:
  try:
    f=open(cifname)
    f.close   

  except IOError:
    sys.stdout = Logger("validation_errors.txt")   
    print " IOError: %s file can not be opened"%(cifname)
    sys.exit()

  try:
   cif_model=iotbx.cif.reader(file_path=cifname).model()
  except Exception as error:
   sys.stdout = Logger("errors.txt")
   print repr(error)
   sys.exit()


 file_errors=open("errors.txt","w")
 cifdic=validation.smart_load_dictionary(file_path="dic_total.dic.gz")
 error=cif_model.validate(cifdic, show_warnings=True,out=file_errors)
 if error.error_count==0 and error.warning_count==0:
  import datasearch
  datanames=datasearch.dataname(cifname)
  return datanames
 else:
  errorv=1
  return errorv
 file_errors.close 

 
b=validate('myfile.cif')
print b


