def cifcreation(programname,cifmod,dataname,cifshort,txtname):
 import iotbx.cif 
 from iotbx.cif import model
 from iotbx.cif import validation
 from iotbx.cif import builders
 import math
 from tabulate import tabulate
 import sys
 import ast

 filecif=open(cifshort,'w')
 filetxt=open(txtname,'w')
 
 cif = model.cif()
 cif_block = model.block()

 class Logger(object):
    def __init__(self, filename="Default.log"):
        self.terminal = sys.stdout
        self.log = open(filename, "w")

    def write(self, message):
        self.terminal.write(message)
        self.log.write(message)
        self.log.close

 try:
  structure = iotbx.cif.reader(file_path=cifmod).build_crystal_structures()[dataname]

 except Exception as error:
   sys.stdout = Logger("errors.txt")
   print ("CifBuilderError:"+str(error)) 
   sys.exit()


#######################################
# Determination of the parameters required

 a=str(programname)
 b=a+".txt"
 file=open(b,"r")
 for line in file.readlines():
  c=line
 parameterdic=ast.literal_eval(c)

 file.close


#parameterlist=[a,b,c,alpha,beta,gamma,ITA,atom_label,indep_atoms,comments,atom_type,ID,NUMBER,OCC,WP,X,Y,Z,BISO,SCAT]
# if parameterlist[i]==0 include
# if parameterlist[i]==1 not include





###########################################
#cif block calculation
 
 unit_cell = structure.unit_cell()
 params = unit_cell.parameters()
 space_group = structure.space_group()
 space_group_type=structure.space_group_info().type()
 fmt = "%.6f"
 scatterers=structure.scatterers()
 
 cifmodel=iotbx.cif.reader(file_path=cifmod).model()
 cifblock=cifmodel[dataname]
 
 if parameterdic["a"]==0:
  cif_block["_cell_length_a"] = params[0]
 if parameterdic["b"]==0:
  cif_block["_cell_length_b"] = params[1]
 if parameterdic["c"]==0:
  cif_block["_cell_length_c"] = params[2]
 if parameterdic["alpha"]==0:
  cif_block["_cell_angle_alpha"] = params[3]
 if parameterdic["beta"]==0:
  cif_block["_cell_angle_beta"] = params[4]
 if parameterdic["gamma"]==0:
  cif_block["_cell_angle_gamma"] = params[5]
 if parameterdic["ITA"]==0:
  cif_block["_space_group_IT_number"] = space_group_type.number()


 ID=1
 parameters_cif=[]


 if parameterdic["atom_label"]==0:
  parameters_cif.append('_atom_site_label')
 if parameterdic["X"]==0:
  parameters_cif.append('_atom_site_fract_x')
 if parameterdic["Y"]==0:
  parameters_cif.append('_atom_site_fract_y')
 if parameterdic["Z"]==0:
  parameters_cif.append('_atom_site_fract_z')
 if parameterdic["OCC"]==0:
  parameters_cif.append('_atom_site_occupancy')
 if parameterdic["BISO"]==0:
  parameters_cif.append('_atom_site_B_iso_or_equiv')
 if parameterdic["SCAT"]==0:
  parameters_cif.append('_atom_site_type_symbol')
  atom_type_loop = model.loop(header=('_atom_type_symbol',))
  atom_type=[]

 parameters_cif=tuple(parameters_cif)
 atom_site_loop = model.loop(header=(parameters_cif))
 
 
 for i_seq, sc in enumerate(scatterers):
  values_cif=[]
  site = [fmt % sc.site[i] for i in range(3)]
  if parameterdic["atom_label"]==0:
   atom=sc.label
   atom=list(atom)

   i=0
   if len(atom)!=1:
    while i<len(atom):
     if atom[i].isdigit():
      a=i
      while a<len(atom):
       if not atom[a].isdigit():
        atom=atom[0:a]
        i=len(atom)
        break
       a=a+1
     if i<len(atom) and not atom[i].isalpha() and not atom[i].isdigit():
      atom=atom[0:i]
      break
     i=i+1
    atom="".join(atom)
   else:
    atom=sc.label  

   values_cif.append(atom)

  if parameterdic["X"]==0:
   values_cif.append(site[0])

  if parameterdic["Y"]==0:
   values_cif.append(site[1])

  if parameterdic["Z"]==0:
   values_cif.append(site[2])

  if parameterdic["OCC"]==0:
   values_cif.append(fmt%sc.occupancy)
  

  if parameterdic["BISO"]==0: 
    u_iso_or_equiv = fmt % sc.u_iso_or_equiv(unit_cell)
    B=(8*(math.pi)**2)*float(u_iso_or_equiv)
    BISO=fmt % B
    values_cif.append(BISO)

  if parameterdic["SCAT"]==0:
   atom=sc.label
   atom=list(atom)
   i=0
   if len(atom)!=1:
    while i<len(atom):
     if atom[i].isdigit():
      atom2=atom[0:i]
      break
     if i<len(atom)and not atom[i].isalpha():
      atom2=atom[0:i]
      break
     if i==len(atom)-1:
      atom2=atom  
     i=i+1
    atom="".join(atom2)
   else:
    atom=sc.label 
    number=1

   values_cif.append(atom)
   if len(atom_type)==0:
     atom_type.append(atom)
     atom_type_loop.add_row((atom,))
     cif_block.add_loop(atom_type_loop)
   else:
    for i in range (0,len(atom_type)):
     if atom==atom_type[i]:
      break
     elif i==len(atom_type)-1:
      atom_type.append(atom)
      atom_type_loop.add_row((atom,))
      cif_block.add_loop(atom_type_loop)
      
  
  values_cif=tuple(values_cif) 
  atom_site_loop.add_row(values_cif)
  cif_block.add_loop(atom_site_loop)
  
  
 cif[dataname] = cif_block
 cif.show(out=filecif)

 filecif.seek(0)

 ##############################################################################
# Cif file validation
 
 cif_model=iotbx.cif.reader(file_path=cifshort).model()
 cifdic=validation.smart_load_dictionary(name="cif_core.dic")
 file_error=open("errors.txt","w")
 error=cif_model.validate(cifdic, show_warnings=True,out=file_error)
 file_error.close
 if error.error_count!=0 or error.warning_count!=0:
  sys.exit()
 filecif.close


################################################################################################

 if parameterdic["comments"]==0:
  filetxt.write("# Space Group ITA number ")
  filetxt.write("\n")
 filetxt.write(str(space_group_type.number())+"\n")
 filetxt.write("\n")
 list_lattice=[]
 if parameterdic["a"]==0:
  list_lattice.append(params[0])
  list_lattice.append("  ")
 if parameterdic["b"]==0:
  list_lattice.append(params[1])
  list_lattice.append("  ")
 if parameterdic["c"]==0:
  list_lattice.append(params[2])
  list_lattice.append("  ")
 if parameterdic["alpha"]==0:
  list_lattice.append(params[3])
  list_lattice.append("  ")
 if parameterdic["beta"]==0:
  list_lattice.append(params[4])
  list_lattice.append("  ")
 if parameterdic["gamma"]==0:
  list_lattice.append(params[5])
  list_lattice.append("  ")
 if len(list_lattice)!=0:
  if parameterdic["comments"]==0:
   filetxt.write("# Lattice parameters \n")
  for i in range(0,len(list_lattice)):
   filetxt.write(str(list_lattice[i]))
 filetxt.write("\n")
 filetxt.write("\n")
 numb_atoms=len(scatterers)
 if parameterdic["indep_atoms"]==0:
  if parameterdic["comments"]==0:
   filetxt.write("# Number of independent atoms in the asymmetric unit \n")
  filetxt.write(str(numb_atoms)+"\n")
  filetxt.write("\n")
 

 
 WP=[]
 multiplicity=[]
 
 list_total=[]
 headers = []
 if parameterdic["WP"]==0:
  try:
   multiplicity= cifblock ['_atom_site_site_symmetry_multiplicity'] 
  except Exception:
   try:
    multiplicity= cifblock ['_atom_site_symmetry_multiplicity'] 
   except Exception:
    try:
     multiplicity= cifblock ['_atom_site.symmetry_multiplicity'] 
    except Exception:
     multiplicity.append("?")
  
  if multiplicity[0]=="?":
   Wyckoff_symbol=[]
   Wyckoff_symbol.append("?")
 
  else:
   try:
    Wyckoff_symbol= cifblock ['_atom_site_Wyckoff_symbol'] 

   except Exception:
    try:
     Wyckoff_symbol= cifblock ['_atom_site.Wyckoff_symbol'] 

    except Exception:
     Wyckoff_symbol=[]
     Wyckoff_symbol.append("?")
  
  
 
  
 ID=1
 for i_seq, sc in enumerate(scatterers):
  list_values=[]
  headers = []
  if parameterdic["atom_type"]==0 or parameterdic["SCAT"]==0:   
   atom=sc.label
   atom=list(atom)
   i=0
   number=1
   if len(atom)!=1:
    while i<len(atom):
     if atom[i].isdigit():
      atom2=atom[0:i]
      if i==len(atom)-1:
       number=(atom[i])
       break
      if atom[i+1].isdigit():
       a=i
       while a<len(atom):
        if a==len(atom)-1:
         number=atom[i:a+1]
         i=len(atom)
         break
        elif not atom[a+1].isdigit():
         number=atom[i:a+1]
         i=len(atom)
         break
        a=a+1
      elif not atom[i+1].isdigit():
       number=atom[i]
       number=str(number)
     if i<len(atom)and not atom[i].isalpha():
      atom2=atom[0:i]
      number=str(number)
      i=len(atom)
      break

     if i==len(atom)-1:
      atom2=atom
      number=str(number)
     i=i+1
    atom="".join(atom2)
    number="".join(number)
   else:
    atom=sc.label 
    number=1

  if parameterdic["atom_type"]==0:
    atom_type=atom
    list_values.append(atom)
    headers.append("[atom]")
  if parameterdic["ID"]==0:
    ID=ID
    list_values.append(ID)
    headers.append("[ID]")

  if parameterdic["NUMBER"]==0:
    NUMBER=number
    list_values.append(NUMBER)
    headers.append("[NUMBER]")


  if parameterdic["WP"]==0:
    if Wyckoff_symbol[0]=="?":
     WP=" - "
    else:
     WP=multiplicity[ID-1]+Wyckoff_symbol[ID-1]
  else:
   WP=" - "
  list_values.append(WP)
  headers.append("[WP]")

  
  site = [fmt % sc.site[i] for i in range(3)]   

  if parameterdic["X"]==0:
    X=site[0]
    list_values.append(X)
    headers.append("[X]")
  if parameterdic["Y"]==0:
    Y=site[1]
    list_values.append(Y)
    headers.append("[Y]")
  if parameterdic["Z"]==0:
    Z=site[2]
    list_values.append(Z)
    headers.append("[Z]")

  if parameterdic["OCC"]==0:
    OCC=fmt%sc.occupancy 
    list_values.append(OCC)
    headers.append("[OCC]")
   

  if parameterdic["BISO"]==0: 
    u_iso_or_equiv = fmt % sc.u_iso_or_equiv(unit_cell)
    B=(8*(math.pi)**2)*float(u_iso_or_equiv)
    BISO=fmt % B
    if BISO=="0.000000":
     list_values.append(" ") 
    else:   
     list_values.append(BISO)
    headers.append("[BISO]")
  if parameterdic["SCAT"]==0:
    SCAT=atom
    list_values.append(SCAT)
    headers.append("[SCAT]")

  list_total.append(list_values)
  ID=ID+1
 

 if parameterdic["comments"]==0: 
  if len(list_total)!=0:
   filetxt.write(" #")
   a=tabulate(list_total,headers,tablefmt="plain")
   filetxt.write(a)


 else:
  if len(list_total)!=0:
   a=tabulate(list_total, tablefmt="plain")
   filetxt.write(a)
   
 filetxt.close


























