import iotbx.cif
from iotbx.cif import builders
from iotbx.cif import model
import sys
class Logger(object):
    def __init__(self, filename="Default.log"):
        self.terminal = sys.stdout
        self.log = open(filename, "w")

    def write(self, message):
        self.terminal.write(message)
        self.log.write(message)
        self.log.close


def dataname(cifname):
  
  filecif=open(cifname,'r')
  lines = filecif.readlines()
  datanamelist=[]
  datanamelist2=[]

  for line in lines:
    if line[0:5]=='data_':
     datanameshort=line[5:len(line)-1] 
     datanamelist.append(datanameshort)
  try:
   cifmodel=iotbx.cif.reader(file_path=cifname).model()
  except Exception as error:
   sys.stdout = Logger("errors.txt")
   print repr(error)
   sys.exit()

  for data in datanamelist:

   cif_block=cifmodel[data]
   build=builders.builder_base()
   build.cif_block=cif_block
   a=build.get_cif_item('_cell_length_a')
   b=build.get_cif_item('_cell_length_b')
   c=build.get_cif_item('_cell_length_c')
   alpha=build.get_cif_item('_cell_angle_alpha')
   beta=build.get_cif_item('_cell_angle_beta')
   gamma=build.get_cif_item('_cell_angle_gamma')
   sym_op=build.get_cif_item('_space_group_symop_operation_xyz')
   atom_label=build.get_cif_item('_atom_site_label')
   atom_type=build.get_cif_item('_atom_site_type_symbol')
   atom_fract_x=build.get_cif_item('_atom_site_fract_x')
   atom_fract_y=build.get_cif_item('_atom_site_fract_y')
   atom_fract_z=build.get_cif_item('_atom_site_fract_z')
   append="Yes"
   while True:
    if a==None or a=="?":
     append="No"
     break
    if b==None or b=="?":
     append="No"
     break
    if c==None or c=="?":
     append="No"
     break
    if alpha==None or alpha=="?":
     append="No"
     break 
    if beta==None or beta=="?":
     append="No"
     break  
    if gamma==None or gamma=="?":
     append="No"
     break
    if sym_op==None:
     append="No"
     break
    for sym_ops in sym_op:
     if sym_ops=="?":
      append="No"
      break  
    if atom_label==None:
     append="No"
     break
    for label in atom_label:
     if label=="?":
      append="No"
      break  
    if atom_type==None:
     append="No"
     break
    for a_type in atom_type:
     if a_type=="?":
      append="No"
      break  
    if atom_fract_x==None:
     append="No"
     break
    for fract_x in atom_fract_x:
     if fract_x=="?":
      append="No"
      break  
    if atom_fract_y==None:
     append="No"
     break
    for fract_y in atom_fract_y:
     if fract_y=="?":
      append="No"
      break  
    if atom_fract_z==None:
     append="No"
     break
    for fract_z in atom_fract_z:
     if fract_z=="?":
      append="No"
      break  
    if append=="Yes":
     datanamelist2.append(data)
     break
    break
  filecif.close
  return datanamelist2



#################################################################
def printdata(dn):

     print " "
     print "This file contains", len(dn), "structures:"
     i=0
     while i<len(dn):
       print "- ",dn[i],"--> ",i+1
       i=i+1
     print " "
     
###########################################################3
def cifdata(cifname,cifmod,dataname): 
 
 filecif2=open(cifmod,'w')


 cifmodel=iotbx.cif.reader(file_path=cifname).model()
 cifblock=cifmodel[dataname]
 cif = model.cif()
 cif[dataname] = cifblock
 
 cif.show(out=filecif2)
 
 filecif2.close









