########################################################################################################################
#   This program validates a cif using a concatenation of dictionaries and gives a report of errors if it is  invalid  #       #                                                                                                                     #
####################################################################################################################

import iotbx.cif
import gzip
from iotbx.cif import validation
import sys


class Logger(object):
    def __init__(self, filename="Default.log"):
        self.terminal = sys.stdout
        self.log = open(filename, "w")

    def write(self, message):
        self.terminal.write(message)
        self.log.write(message)
        self.log.close


def cif_dic_from_str(name1,name2):
    on_this_dict = str(validation.smart_load_dictionary(name=name2))
    return on_this_dict+name1

def validate(cifname):
  
 if cifname.endswith(".cif")== False:
   sys.stdout = Logger("errors.txt")
   print " CifBuilderError: %s file is not a cif file"%(cifname)
   sys.exit()
 else: 
   try:
    file1=open(cifname)
    file1.close   

   except IOError:
     sys.stdout = Logger("errors.txt")   
     print " IOError: %s file can not be opened"%(cif)
     sys.exit()

 
 file_errors=open("errors.txt","w")
 cif_dics=["cif_core.dic","cif_pd.dic","cif_rho.dic","cif_twinning.dic","cif_core_restraints.dic","jana.dic","cif_ms.dic"]

 

 if len(cif_dics)>1:
  dic1=str(validation.smart_load_dictionary(name=cif_dics[0]))
  dictotal=cif_dic_from_str(dic1,cif_dics[1])
  if len (cif_dics)>2:
   for d in range(2,len(cif_dics)):
    dictotal=cif_dic_from_str(dictotal,cif_dics[d])
 elif len(cif_dics)==1:
  dictotal=str(validation.smart_load_dictionary(name=cif_dics[0]))
 else:
  dictotal=str(validation.smart_load_dictionary(name="cif_core.dic"))

 with gzip.open('dic_conc.dic.gz', 'wb') as f:
    f.write(dictotal)
 

 try:
   cif_model=iotbx.cif.reader(file_path=cifname).model()
 except Exception as error:
   sys.stdout = Logger("errors.txt")
   print repr(error)
   sys.exit
 
 cifdic=validation.smart_load_dictionary(file_path="dic_conc.dic.gz")
 error=cif_model.validate(cifdic, show_warnings=True, out=file_errors) 
 file_errors.close
 
 

validate("myfile.cif")

