##########################################################################################################################
#                                                                                                                       #
#  This program validates a set of cifs contained in the cif directory and creates a report of errors for each cif file #
#######################################################################################################################
def print_errors():
 import os
 import sys
 import iotbx.cif
 from iotbx.cif import validation 
 
 lstFiles = []
 name="cif/"
 lstDir = os.walk(name)
 for file1 in lstDir:
    for fichero in file1:
      for fich in fichero:
        if fich.endswith(".cif"):
         lstFiles.append(fich)


        
 for fich in lstFiles:
   cifname=name+fich
   archivo, extension = os.path.splitext(fich)
   file_name="cif_errors/"+"/"+archivo+"/"+archivo+"_errors.txt"
   directory = os.path.dirname(file_name)
   try: 
    os.makedirs(directory)
   except OSError:
    if not os.path.isdir(directory):
        raise

   file1=open(file_name,"w")
   
   try:
    cif_model=iotbx.cif.reader(file_path=cifname).model()
    cifdic=validation.smart_load_dictionary(file_path="dic_total.dic.gz")
    error=cif_model.validate(cifdic, show_warnings=True, out=file1) 
   except Exception as error:
    file1.write("There is a CifParserError please correct it ")
    file1.write(str(error))
    
    
   
   file1.close
   

print_errors()
